<template>
  <div>
    <h4>{{ title }}</h4>
    {{ nodeData }}
    <div v-for="(value, key) in nodeData" :key="key" v-if="!excludeList.includes(key)">
      <div v-if="fieldsConfig[key]">
        <div v-if="fieldsConfig.paragraph" class="paragraph">
          <div v-if="!fieldsConfig.multi">
            <items-form :title="nodeData[key]._type + ' #' + nodeData[key].pid" :node="node" :path="[...path, key]" :config="fieldsConfig.ref[nodeData[key]._type]"></items-form>
            <!-- <label>
              {{ fieldsConfig.label }}
              <component :is="'text-field'" :node="node" :config="fieldsConfig"></component>
            </label> -->
          </div>
          <div v-else>
            <div v-for="(embed, index) in nodeData[key]" :key="embed.pid">
              <items-form :title="embed._type + ' #' + embed.pid" :node="node" :path="[...path, key, index]" :config="fieldsConfig.ref[embed._type]"></items-form>
            </div>
          </div>
        </div>
        <div v-else>
          <div v-if="!fieldsConfig.multi">
            <label>
              {{ fieldsConfig.label }} {{ [...path, key] }}
              <component :is="'text-field'" :node="node" :path="[...path, key]" :config="fieldsConfig"></component>
            </label>
          </div>
          <div v-else>
            <!-- <div v-for="embed in node[key]" :key="embed.nid">
              <items-form :title="key + ' #' + embed.nid" :node="embed" :config="fieldsConfig"></items-form>
            </div> -->
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

// import { mapGetters } from 'vuex'

import TextField from '@/components/Editable/Fields/Widgets/TextFieldWidgetField'

export default {
  components: {
    TextField,
    ItemsForm: () => import('./ItemsForm.vue')
  },

  props: {
    title: {
      type: String,
      required: true
    },
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: false,
      default: () => []
    },
    config: {
      type: Object,
      required: true
    }
  },

  data () {
    return {
      excludeList: ['_type', 'nid']
    }
  },

  computed: {
    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    },

    fieldsConfig () {
      return this.config.fields || {}
    }
    // ...mapGetters({
    //   getEditableNodes: 'Y3TI/getEditableNodes',
    //   getFieldConfig: 'Y3TI/getFieldConfig'
    // }),

    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
  .paragraph {
    border: 1px solid black;
    padding: 5px;
  }
</style>
